var cssHashCode  = function() {
  var hash = 5381, i = this.length
  while(i)
    hash = (hash * 33) ^ this.charCodeAt(--i)
  return hash >>> 0;
};

jQuery(document).ready(function() {
	cssHashCode(document.location.href);
	$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
	  var target = $(e.target).attr("href") // activated tab
	  $.cookie('target', target, { expires: 7 });
	});

	if($.cookie('target') != 'undefined') {
		$("li.tab a[href='" + $.cookie('target') + "']").tab('show');
	}
	
	$(".content-header").addClass("css-content");
	
	$(".css-content ").each(function() {
		$(this).html('<div class="inner">' + $(this).html() + '</div>').append('<div class="text-center css-more-button"><span class="fa fa-angle-double-down"></span></div>');
	});

	$(".content-header").prepend($(".css-content .row").remove());
	
	$("body").on("click",".css-more-button", function() {
		$(this).closest(".css-content").addClass("load");
		if($(this).closest(".css-content").hasClass("in")) {
		} else {
			$("body .css-content.in").not(".load").removeClass("in").find(".inner.in").slideUp(500).removeClass("in");
		}
		$(this).closest(".css-content").removeClass("load");
		$(this).closest(".css-content").find(".inner").slideDown(500, function() {
			if($(this).closest(".versandoption").length) {
				 $([document.documentElement, document.body]).animate({
		        scrollTop: $(this).closest(".versandoption").offset().top - 100
		    }, 1000);
			}
			});
		$(this).closest(".css-content").find(".inner.in").slideUp(500);
		$(this).closest(".css-content").find(".inner").toggleClass("in");
		$(this).closest(".css-content").toggleClass("in");
	});
	
});

(function () {
    'use strict';

    var cssShippingClass = function (options) {
        this.init(options);
    };

    cssShippingClass.VERSION = '1.0.0';
    cssShippingClass.DEFAULTS = { 
  			showDebug : true,
  			confirmTemplate: '\
  				<div class="modal fade" id="confirmation_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<form role="form" method="post" action="category_delete" id="delete_data">\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-danger confirmYes" >Ja ich m&ouml;chte</button>\
			    					<button type="button" class="btn btn-primary" data-dismiss="modal">Nein ich m&ouml;chte nicht</button>\
			    				</div>\
			    			</form>\
			    		</div>\
			    	</div>\
			    </div>\
			',
  			noticeTemplate: '\
  				<div class="modal fade " id="css_shipping_modal" role="dialog" style="display: none;">\
			    	<div class="modal-dialog">\
			    				<div class="modal-content">\
			    			<div class="modal-header">\
			    				<h4 class="modal-title"></h4>\
			    			</div>\
    			<div class="modal-body">\
  				</div>\
			    			<!-- <form role="form" method="post" action="" >\
			    				<div class="modal-footer">\
			    					<button type="button" class="btn btn-default" data-dismiss="modal">schlie&szlig;en</button>\
			    				</div>\
			    			</form>-->\
			    		</div>\
			    	</div>\
			    </div>\
			'
    };
    cssShippingClass.prototype = {

        constructor: cssShippingClass,

        init: function (options) {
            this.options = $.extend({}, cssShippingClass.DEFAULTS, options);
            var that = this;
        },

        register: function(options) {
        	var that=this;
        	this.debug("function register started");
        	this.initSelectVersand();
        	this.initDeleteButton();
        },
        
        debug: function(s) {
        	if(this.options.showDebug) {
        		console.log(s);
        	}
        },

        initDeleteButton: function() {
        	var that = this;
        	$("#content").on("click", "button[name='delete']", function() {
        		that.debug("is clicked");

        		if(!$(this).hasClass("confirmed")) {
      				that.openModalConfirmation(this,"alert alert-danger", "Warning", "Sind Sie sicher das Sie diesen Eintrag l&ouml;schen m&ouml;chten?");
        			return;	
      			} else {
      				var shippingId = $(this).closest(".versandoption").find(".shippingId").val();
  						$("select.versand").find("option[value='" + Number(shippingId) + "']").removeClass("hidden").attr("disabled",false);

      				that.debug(shippingId);
      				that.post_data("","cssAdminConfigAction=deleteShippingConfig&ShippingConfig="+ shippingId + "&jtl_token=" + $(this).closest("form").find("input[name='jtl_token']").val());
  						var shippingId = $(this).closest(".versandoption").slideUp("slow",function() {
  							$(this).remove();
  						});
      			}
        	});
        },
        
    		openModalConfirmation: function (el, selector, titel,content) {
    			$("#confirmation_modal").remove();
    			$("body").append(this.options.confirmTemplate);
    			$("#confirmation_modal .modal-content").addClass(selector);
    			$("#confirmation_modal .modal-title").html(titel);
    			$("#confirmation_modal .modal-body").html(content);
    			$("#confirmation_modal .confirmYes").on("click", function() {
    				$(el).addClass("confirmed").trigger("click").removeClass("confirmed");
    				$("#confirmation_modal").modal("hide");
    			});
    			$("#confirmation_modal").modal("show");
    		},
        
        initSelectVersand: function() {
        	var that=this;
        	$("body").on("change","select.versand", function() {
        		that.debug("select.versand Element was changed");
        		var shippingValue = $(this).val();
        		var shippingName = $(this).find('option:selected').html();
        		that.debug("Name = " + shippingName + " / Value = " + shippingValue);
        		if(! shippingValue) return;
        		$(this).find('option:selected').addClass("hidden").attr("selected",false);
        		that.debug("Name of Value:  " + shippingName);
        		var html = $("#versandvorlage").clone();
        		$(html).find(".versandTitel").html(shippingName);
//        		$(html).find(".css-more-button").unbind('click');
        		$(html).find("input.calendar").attr("name","closedDays[" + shippingValue + "]");
        		$(html).find("select.closedByKupon").attr("name","closedByKupon[" + shippingValue + "]");
        		$(html).find("select.closedByDuration").attr("name","closedByDuration[" + shippingValue + "]");
        		$(html).find("select.usePackage").attr("name","usePackage[" + shippingValue + "]");
        		$(html).find("input.closedTimeStart").attr("name","closedTimeStart[" + shippingValue + "]");
        		$(html).find("input.markUpInPercent").attr("name","markUpInPercent[" + shippingValue + "]");
        		$(html).find("input.mileageAllowance").attr("name","mileageAllowance[" + shippingValue + "]");
        		$(html).find("input.country").attr("name","country[" + shippingValue + "]");
        		$(html).find("input.zipCode").attr("name","zipCode[" + shippingValue + "]");
        		$(html).find("input.showInfo").attr("name","showInfo[" + shippingValue + "]");
        		$(html).find("input.minimumQuantitySurcharge").attr("name","minimumQuantitySurcharge[" + shippingValue + "]");
        		
        		$(html).find(".openDays input").attr("name","openDays[" + shippingValue + "][]");
        		$(html).find("input.shippingId").val(shippingValue);
        		$(html).find(".versandoption").attr("data-id",shippingValue).attr("id","versand_" + Number(shippingValue));
        		$("#versandoptionen").prepend($(html).html());
        		that.debug(".versandoption[data-id='"+Number(shippingValue)+"']  .css-more-button");
        		$(".versandoption[data-id='"+Number(shippingValue)+"']  .css-more-button").trigger("click");
        	});
        },
        
    		openModalNotice: function (el, selector, titel,content) {
    			$("#css_shipping_modal").remove();
    			$("body").append(this.options.noticeTemplate);
    			if(selector) $("#css_shipping_modal .modal-content").addClass(selector);
    			$("#css_shipping_modal .modal-title").html(titel);
    			$("#css_shipping_modal .modal-body").html(content);
    			$("#css_shipping_modal").modal("show");
    		},

    		post_data: function (url, data) {
    			var that = this;
	      	jQuery.ajax({
					type: 'POST',
					url: url,
					data: data,
					showNoSuggestionNotice: true,
					dataType: 'json',
			    beforeSend: function(jqXHR) {
		        jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
			    },
					success: function(data,responseText,jqXHR) {
						if( jqXHR.status == 204 ) {
							that.debug('sorry, here is nothing to do for me. (Token problem?)')
							return false;
						}
						if( jqXHR.status == 404 ) {
							that.debug('sorry, here is nothing to show you.')
							return false;
						}
						if( jqXHR.status == 403 ) {
							that.debug('sorry, this is no place for you.')
							return false;
						}
						//debug(data);
						if( data.script )	{
							eval(data.script);
						}
            $("body").trigger('contentChanged');
					},
					error: function() {
						that.debug('something is wrong....anything buggy?');
					},
					complete: function() {
							
					}
			});
		},
   };

    $.cssShipping = function(options) {
    	$.cssSh = new cssShippingClass(options);
    	$.cssSh.register();
    	return $.cssSh;
    };
})(jQuery);

$(document).ready(function () {
	$.cssShipping({
		showDebug : true,
	});
});

